<?php 
##
#	Project: PHPDisk Personal Edition
#	This is NOT a freeware, use is subject to license terms.
#
#	Site: http://www.phpdisk.com
#
#	$Id: account.php 180 2009-07-26 13:47:06Z along $
#
#	Copyright (C) 2008-2009 PHPDisk Team. All Rights Reserved.
#
##

include "includes/commons.inc.php";

$in_front = true;

require_once lang('account');
$lang = array_merge($pub_lang,$lang);
$title = $lang['account'][$action];
include PHPDISK_ROOT."./includes/header.inc.php";

switch($action){
	case 'relogin':
	case 'login':

		$ref = trim(gpc('ref','GP',''));
		
		if($task =='login'){

			if($p_formhash != formhash()){
				exit($lang['system_error']);
			}
			$username = $db->escape(gpc('username','P',''));
			$password = $db->escape(gpc('password','P',''));
			$md5_pwd = md5($password);
			$remember = (int)gpc('remember','P',0);
			$verycode = trim(gpc('verycode','P',''));
			
			if(checklength($username,2,60)){
				$error = true;
				$sysmsg[] = $lang['invalid_username'];
			}
			if(checklength($password,6,20)){
				$error = true;
				$sysmsg[] = $lang['invalid_password'];
			}
			if($settings['login_verycode']){
				session_start();
				if (!$verycode || strtolower($verycode) != strtolower($_SESSION['verycode'])) {
					unset($_SESSION['verycode']);
					$error = true;
					$sysmsg[] = $lang['invalid_verycode'];
				}
			}
			
			$rs = $db->fetch_one_array("select userid,gid,username,password,email,is_locked from {$tpf}users where username='$username' limit 1");
			if(!$rs){
				$error = true;
				$sysmsg[] = $lang['user_not_exists'];
			}else{
				if($md5_pwd != $rs['password']){
					$error = true;
					$sysmsg[] = $lang['user_password_false'];
				}elseif($rs['is_locked']){
					$error = true;
					$sysmsg[] = $lang['user_is_locked'];
				}else{
					$userid = (int)$rs['userid'];
					$gid = (int)$rs['gid'];
					$username = trim($rs['username']);
					$password = trim($rs['password']);
					$email = trim($rs['email']);
				}
			}
			//# only admin can login
			if(!$settings['allow_access'] && $gid !=1){
				$error = true;
				$sysmsg[] = $lang['admin_not_valid'];
			}
			if(!$error){
				$db->query_unbuffered("update {$tpf}users set last_login_ip='$onlineip',last_login_time='$timestamp' where userid='$userid'");
				if($remember){
					pd_setcookie('phpdisk_info',pd_encode("$userid\t$gid\t$username\t$password\t$email"),86400*30);
				}else{
					pd_setcookie('phpdisk_info',pd_encode("$userid\t$gid\t$username\t$password\t$email"));
				}
				redirect($ref ? $ref : urr("index",""),'',0);
			}
		} 
		//# end login action
		if(!$settings['allow_access']){
			$sysmsg[] = $lang['close_access'];
		}
		$user_title = $lang['user_login'];
		require_once template_echo('pd_account',TPL_NAME);

	break;
	
	case 'adminlogin':
	
		$ref = trim(gpc('ref','GP',''));
		$username = $pd_username;
		
		if($task =='adminlogin'){

			if($p_formhash != formhash()){
				exit($lang['system_error']);
			}
			$username = $db->escape(gpc('username','P',''));
			$password = $db->escape(gpc('password','P',''));
			$md5_pwd = md5($password);

			if(checklength($username,2,60)){
				$error = true;
				$sysmsg[] = $lang['invalid_username'];
			}
			if(checklength($password,6,20)){
				$error = true;
				$sysmsg[] = $lang['invalid_password'];
			}
			$rs = $db->fetch_one_array("select userid,gid,username,password,email from {$tpf}users where username='$username' limit 1");
			if(!$rs){
				$error = true;
				$sysmsg[] = $lang['user_not_exists'];
			}else{
				if($md5_pwd != $rs['password']){
					$error = true;
					$sysmsg[] = $lang['user_password_false'];
				}else{
					$userid = (int)$rs['userid'];
					$gid = (int)$rs['gid'];
					$username = trim($rs['username']);
					$password = trim($rs['password']);
					$email = trim($rs['email']);
				}
			}
			
			if(!$error && $gid ==1 && $pd_uid){
				$ins = array(
					'userid' => $pd_uid,
					'login_time' => $timestamp,
					'hashcode' => gpc('phpdisk_info','C',''),
					'ip' => $onlineip,
				);
				$rs = $db->fetch_one_array("select count(*) as total from {$tpf}adminsession where userid='$pd_uid'");
				if($rs['total'] ==0){
					$db->query("replace into {$tpf}adminsession set ".$db->sql_array($ins).";");
				}else{
					$db->query("update {$tpf}adminsession set ".$db->sql_array($ins)." where userid='$pd_uid' and $timestamp-login_time >10");
				}
				unset($rs);
				redirect(urr("admincp",""),'',0);
			}else{
				if(!count($sysmsg)){
					$sysmsg[] = $lang['admin_not_valid'];
				}
			}
		}
		$user_title = $lang['admin_login'];
		require_once template_echo('pd_account',TPL_NAME);
	break;
	
	case 'register':

		if($task == 'register'){
			
			if($p_formhash != formhash()){
				exit($lang['system_error']);
			}
			$username = trim(gpc('username','P',''));
			$password = trim(gpc('password','P',''));
			$confirm_password = trim(gpc('confirm_password','P',''));
			$email = trim(gpc('email','P',''));
			$verycode = trim(gpc('verycode','P',''));
			
			//# username
			if(checklength($username,2,60)){
				$error = true;
				$sysmsg[] = $lang['invalid_username'];
			}elseif(is_bad_chars($username)){
				$error = true;
				$sysmsg[] = $lang['username_has_bad_chars'];
			}else{
				$rs = $db->fetch_one_array("select username from {$tpf}users where username='".$db->escape($username)."' limit 1");
				if($rs){
					if(strcasecmp($username,$rs['username']) ==0){
						$error = true;
						$sysmsg[] = $lang['username_already_exists'];
					}
				}else{
					$username = $db->escape($username);
				}
				unset($rs);
			}
			//# password
			if(checklength($password,6,20)){
				$error = true;
				$sysmsg[] = $lang['invalid_password'];
			}else{
				if($password == $confirm_password){
					$md5_pwd = md5($password);
				}else{
					$error = true;
					$sysmsg[] = $lang['confirm_password_invalid'];
				}
			}
			//# email
			if(!checkemail($email)){
				$error = true;
				$sysmsg[] = $lang['invalid_email'];
			}else{
				$rs = $db->fetch_one_array("select email from {$tpf}users where email='".$db->escape($email)."' limit 1");
				if($rs){
					if(strcasecmp($email,$rs['email']) ==0){
						$error = true;
						$sysmsg[] = $lang['email_already_exists'];
					}
					unset($rs);
				}else{
					$email = $db->escape($email);
				}
			}
			//# very code
			if($settings['register_verycode']){
				session_start();
				if (!$verycode || strtolower($verycode) != strtolower($_SESSION['verycode'])) {
					unset($_SESSION['verycode']);
					$error = true;
					$sysmsg[] = $lang['invalid_verycode'];
				}
			}
			$ins = array(
				'username' => $username,
				'password' => $md5_pwd,
				'email' => $email,
				'gid' => 4,
				'reg_time' => $timestamp,
				'reg_ip' => $onlineip,
			);
			if(!$error){
				$db->query("insert into {$tpf}users set ".$db->sql_array($ins).";");
				//# update stats
				$rs = $db->fetch_one_array("select count(*) as total from {$tpf}users ");
				if($rs){
					$db->query("replace into {$tpf}stats (vars,value) values('users_count','".$rs['total']."');");
					write_cache('stats');
				}
				unset($rs);
				$sysmsg[] = $lang['register_success'];
				$reg_success = 1;
			}
		}
		if(!$settings['allow_register']){
			$sysmsg[] = $lang['close_register'];
			if($settings['close_register_reason']){
				$sysmsg[] = 'Tips: '.$settings['close_register_reason'];
			}
		}
		$user_title = $lang['user_register'];
		require_once template_echo('pd_account',TPL_NAME);
		
	break;
	
	case 'logout':
		pd_setcookie('phpdisk_info','');
		redirect(urr("index",""),'',0);
	break;
	
	case 'demologin':
		if(!$settings['open_demo_login']){
			$sysmsg[] = $pub_lang['demo_login_not_open'];
			require_once template_echo('pd_account',TPL_NAME);
		}else{
			$gid = 4;
			$username = 'phpdisk_demo';
			$password = 'fcf41657f02f88137a1bcf068a32c0a3';
			$email = 'demo@phpdisk.com';
			
			$rs = $db->fetch_one_array("select * from {$tpf}users where username='$username'");
			if(!$rs){
				$ins = array(
					'gid' => $gid,
					'username' => $db->escape($username),
					'password' => $password,
					'email' => $email,
					'reg_ip' => $onlineip,
					'reg_time' => $timestamp,
				);
				$db->query("insert into {$tpf}users set ".$db->sql_array($ins).";");
			
			}else{
				$db->query_unbuffered("update {$tpf}users set last_login_ip='$onlineip',last_login_time='$timestamp' where userid='{$rs['userid']}'");
			}
			unset($rs);
			
			$rs = $db->fetch_one_array("select * from {$tpf}users where username='$username'");
			if($rs){
				$userid = $rs['userid'];
				$gid = $rs['gid'];
				$username = $rs['username'];
				$password = $rs['password'];
				$email = $rs['email'];
			}
			unset($rs);
			
			pd_setcookie('phpdisk_info',pd_encode("$userid\t$gid\t$username\t$password\t$email"));
			
			redirect(urr("mydisk",""),'',0);
		}
	break;

	default:
		redirect(urr("account","action=login"),'',0);
}

include PHPDISK_ROOT."./includes/footer.inc.php";


?>

