<?php 
##
#	Project: PHPDisk Personal Edition
#	This is NOT a freeware, use is subject to license terms.
#
#	Site: http://www.phpdisk.com
#
#	$Id: report.inc.php 146 2009-06-22 15:52:29Z along $
#
#	Copyright (C) 2008-2009 PHPDisk Team. All Rights Reserved.
#
##

if(!defined('IN_PHPDISK') || !defined('IN_ADMINCP')) {
	exit('[PHPDisk] Access Denied');
}
phpdisk_admin();
define('SCRIPT_NAME',$item);

require_once lang('adm_'.SCRIPT_NAME);

$lang = array_merge($pub_lang,$lang);

switch($action){
	case 'user':
		$title = $lang['report_user_title'];
		$tips = $lang['report_user_tips'];
		if($task =='change_status'){
			if($p_formhash != formhash()){
				exit($lang['system_error']);
			}
			$file_ids = gpc('file_ids','P',array());
			
			if(!count($file_ids)){
				$error = true;
				$sysmsg[] = $lang['please_select_operation_files'];
			}
			if(!$error){
				for($i=0;$i<count($file_ids);$i++){
					$file_str .= $file_ids[$i].',';
				}
				$file_str = substr($file_str,0,-1);
				$db->query_unbuffered("update {$tpf}files set report_status=0,is_locked=1 where file_id in ($file_str)");
				$sysmsg[] = $lang['locked_file_success'];
				redirect($_SERVER['HTTP_REFERER'],$sysmsg);
			}else{
				redirect("javascript:history.back();",$sysmsg);
			}	
		}else{
			$sql_ext = "{$tpf}files fl,{$tpf}users u where fl.userid=u.userid and report_status=1 and fl.is_locked=0";
			$rs = $db->fetch_one_array("select count(*) as total_num from {$sql_ext}");
			$total_num = $rs['total_num'];
			$start_num = ($pg-1) * $perpage;
			
			$q = $db->query("select fl.*,u.username from {$sql_ext} order by file_id desc limit $start_num,$perpage");
			$files_array = array();
			while($rs = $db->fetch_array($q)){
				$tmp_ext = $rs['file_extension'] ? '.'.$rs['file_extension'] : "";
				$rs['file_name_all'] = $rs['file_name'].$tmp_ext;
				$rs['file_name'] = cutstr($rs['file_name'].$tmp_ext,35);
				$rs['file_size'] = get_size($rs['file_size']);
				$rs['file_time'] = date("Y-m-d",$rs['file_time']);
				$rs['a_downfile'] = urr("downfile","file_id={$rs['file_id']}&file_key={$rs['file_key']}");
				$rs['a_viewfile'] = urr("viewfile","file_id={$rs['file_id']}&file_key={$rs['file_key']}");
				$rs['status_txt'] = '<span class="txtblue">'.$lang['common_status'].'</span>';
				$rs['owner'] = '<a href="'.urr("space","uid={$rs['userid']}").'" target="_blank">'.$rs['username'].'</a>';
				$rs2 = $db->fetch_one_array("select username from {$tpf}reports r, {$tpf}users u where r.userid=u.userid and r.id='{$rs['id']}'");
				$rs['reporter'] = $rs2['username'] ? '<a href="'.urr("space","uid={$rs['userid']}").'" target="_blank">'.$rs2['username'].'</a>' : '--';
				$rs['reason'] = str_replace("\r\n",' ',preg_replace("/<.+?>/i","",$rs2['content']));
				$files_array[] = $rs;
			}
			$db->free($q);
			unset($rs);
			$page_nav = multi($total_num, $perpage, $pg, urr("admincp","item=$item&action=$action"));
			require_once template_echo(SCRIPT_NAME,ADMIN_TPL_NAME);
		}
		
	break;
	
	case 'system':
		$title = $lang['report_system_title'];
		$tips = $lang['report_system_tips'];
		if($task =='change_status'){
			if($p_formhash != formhash()){
				exit($lang['system_error']);
			}
			$file_ids = gpc('file_ids','P',array());
			
			if(!count($file_ids)){
				$error = true;
				$sysmsg[] = $lang['please_select_operation_files'];
			}
			if(!$error){
				for($i=0;$i<count($file_ids);$i++){
					$file_str .= $file_ids[$i].',';
				}
				$file_str = substr($file_str,0,-1);
				$db->query_unbuffered("update {$tpf}files set report_status=0,is_locked=1 where file_id in ($file_str)");
				$sysmsg[] = $lang['locked_file_success'];
				redirect($_SERVER['HTTP_REFERER'],$sysmsg);
			}else{
				redirect("javascript:history.back();",$sysmsg);
			}	
		}else{
			$sql_ext = "{$tpf}files fl,{$tpf}users u where fl.userid=u.userid and report_status=2 and fl.is_locked=0";
			$rs = $db->fetch_one_array("select count(*) as total_num from {$sql_ext}");
			$total_num = $rs['total_num'];
			$start_num = ($pg-1) * $perpage;
			
			$q = $db->query("select * from {$sql_ext} order by file_id desc limit $start_num,$perpage");
			$files_array = array();
			while($rs = $db->fetch_array($q)){
				$tmp_ext = $rs['file_extension'] ? '.'.$rs['file_extension'] : "";
				$rs['file_name_all'] = $rs['file_name'].$tmp_ext;
				$rs['file_name'] = cutstr($rs['file_name'].$tmp_ext,35);
				$rs['file_size'] = get_size($rs['file_size']);
				$rs['file_time'] = date("Y-m-d",$rs['file_time']);
				$rs['a_downfile'] = urr("downfile","file_id={$rs['file_id']}&file_key={$rs['file_key']}");
				$rs['a_viewfile'] = urr("viewfile","file_id={$rs['file_id']}&file_key={$rs['file_key']}");
				$rs['status_txt'] = '<span class="txtblue">'.$lang['common_status'].'</span>';
				$rs['owner'] = '<a href="'.urr("space","uid={$rs['userid']}").'" target="_blank">'.$rs['username'].'</a>';
				$rs2 = $db->fetch_one_array("select username,content from {$tpf}reports r, {$tpf}users u where r.userid=u.userid and r.id='{$rs['id']}'");
				$rs['reporter'] = $rs2['username'] ? '<a href="'.urr("space","uid={$rs['userid']}").'" target="_blank">'.$rs2['username'].'</a>' : '--';
				$rs['reason'] = str_replace("\r\n",' ',preg_replace("/<.+?>/i","",$rs2['content']));
				$files_array[] = $rs;
			}
			$db->free($q);
			unset($rs);
			$page_nav = multi($total_num, $perpage, $pg, urr("admincp","item=$item&action=$action"));
			require_once template_echo(SCRIPT_NAME,ADMIN_TPL_NAME);
		}
		
	break;
	
	case 'file_unlocked':
		$title = $lang['report_unlocked_title'];
		$tips = $lang['report_unlocked_tips'];
		if($task =='change_status'){
			if($p_formhash != formhash()){
				exit($lang['system_error']);
			}
			$file_ids = gpc('file_ids','P',array());
			
			if(!count($file_ids)){
				$error = true;
				$sysmsg[] = $lang['please_select_operation_files'];
			}
			if(!$error){
				for($i=0;$i<count($file_ids);$i++){
					$file_str .= $file_ids[$i].',';
				}
				$file_str = substr($file_str,0,-1);
				$db->query_unbuffered("update {$tpf}files set is_locked=0 where file_id in ($file_str)");
				$sysmsg[] = $lang['unlocked_file_success'];
				redirect($_SERVER['HTTP_REFERER'],$sysmsg);
			}else{
				redirect("javascript:history.back();",$sysmsg);
			}	
		}else{
			$sql_ext = "{$tpf}files fl,{$tpf}users u where u.userid=fl.userid and fl.is_locked=1";
			$rs = $db->fetch_one_array("select count(*) as total_num from {$sql_ext}");
			$total_num = $rs['total_num'];
			$start_num = ($pg-1) * $perpage;
			
			$q = $db->query("select * from {$sql_ext} order by file_id desc limit $start_num,$perpage");
			$files_array = array();
			while($rs = $db->fetch_array($q)){
				$tmp_ext = $rs['file_extension'] ? '.'.$rs['file_extension'] : "";
				$rs['file_name_all'] = $rs['file_name'].$tmp_ext;
				$rs['file_name'] = cutstr($rs['file_name'].$tmp_ext,35);
				$rs['file_size'] = get_size($rs['file_size']);
				$rs['file_time'] = date("Y-m-d",$rs['file_time']);
				$rs['a_downfile'] = urr("downfile","file_id={$rs['file_id']}&file_key={$rs['file_key']}");
				$rs['a_viewfile'] = urr("viewfile","file_id={$rs['file_id']}&file_key={$rs['file_key']}");
				$rs['status_txt'] = '<span class="txtred">'.$lang['locked_status'].'</span>';
				$rs['owner'] = '<a href="'.urr("space","uid={$rs['userid']}").'" target="_blank">'.$rs['username'].'</a>';
				$rs2 = $db->fetch_one_array("select username from {$tpf}reports r, {$tpf}users u where r.userid=u.userid and r.id='{$rs['id']}'");
				$rs['reporter'] = $rs2['username'] ? '<a href="'.urr("space","uid={$rs['userid']}").'" target="_blank">'.$rs2['username'].'</a>' : '--';
				$files_array[] = $rs;
			}
			$db->free($q);
			unset($rs);
			$page_nav = multi($total_num, $perpage, $pg, urr("admincp","item=$item&action=$action"));
			require_once template_echo(SCRIPT_NAME,ADMIN_TPL_NAME);
		}
	break;
	
	case 'setting':
	
		if($task =='update'){
			if($p_formhash != formhash()){
				exit($lang['system_error']);
			}
			$report_word = trim(gpc('report_word','P',''));
			
			if($report_word){
				$report_word = str_replace('',',',$report_word);
				$arr = explode(',',$report_word);
				for($i=0;$i<count($arr);$i++){
					if(trim($arr[$i])){
						$str .= trim($arr[$i]).',';
					}
				}
				$report_word = substr($str,0,-1);
				$db->query("replace into {$tpf}settings(vars,value) values('report_word','$report_word');");
				write_cache('settings');
				$sysmsg[] = $lang['report_success'];
				redirect(urr("admincp","item=report&action=setting"),$sysmsg);
			}else{
				redirect(urr("admincp","item=report&action=setting"),'',0);
			}	
		}else{
			require_once template_echo(SCRIPT_NAME,ADMIN_TPL_NAME);
		}
	break;
}

?>